/***************************************************************************
 *   Copyright (C) 2006 by Felice Murolo, Salerno, Italia   *
 *   linuxboy@felRE-MO-VE.sytes.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 *   Biof Original sources, (c) 2002 by <hk@dgmr.nl>                       *
 *   Ported to Linux by Tugrul Galatali <tugrul@galatali.com>              *
 *   Rewritten and adapted to KDE Environment by Felice Murolo             *
 *                                                                         *
 ***************************************************************************/


#ifndef kbiof_H__
#define kbiof_H__

#include "kscreensaver.h"
#include "kbiofui.h"
#include <qgl.h>

class kbiof : public KScreenSaver
{
    Q_OBJECT
public:
    kbiof( WId drawable );
    virtual ~kbiof();
private:
    void readSettings();
    void blank();
};

class kbiofSetup : public kbiofUI
{
    Q_OBJECT
public:
    kbiofSetup( QWidget *parent = NULL, const char *name = NULL );

private slots:
    void slotOkPressed();
    void slotCancelPressed();
    void urlClick();
	 void typecbTxtChange();


private:
    void readSettings();
    kbiof *saver;
};

// classe della finestra openGL nella quale saranno mostrati
// gli oggetti in rendering openGL
class GWidget : public QGLWidget
{
public:
    GWidget( QWidget *parent=0, const char *name=0 );
    virtual ~ GWidget();
protected:
    void initializeGL();
    void resizeGL( int, int );
    void paintGL();
    void timerEvent( QTimerEvent * );
};

// Funzioni adattate del sorgente originale
void hack_init ();
void hack_reshape ();
void setDefaults (int preset);
void hack_draw (double currentTime, float lastFrameDuration);
void Horn (int ribs, double bend, double stack, double twist, double twisttrans, double grow);


#endif
